## ----exComment-----------------------------------------------------------
# this is a comment in a R script
data(iris)

## ----firstCalculus-------------------------------------------------------
log((1 + sqrt(3)/2)^4)

## ----firstVariable-------------------------------------------------------
a <- cos(pi/4)
a
b = sin(pi/3+1)
b

## ----variableMode--------------------------------------------------------
mode(a)
is.numeric(a)

## ----variableInteger-----------------------------------------------------
b <- 1L; mode(b)
is.integer(b); is.integer(a); is.numeric(b)

## ----variableCharacter---------------------------------------------------
b <- a; b; mode(b)
b <- "a"; b; mode(b)

## ----variableCharacter2--------------------------------------------------
b <- as.character(a); b; mode(b)
b <- as.numeric(b); b; mode(b)

## ----variableCharacter3, warning=TRUE------------------------------------
b <- as.numeric("a"); b;

## ----missingValues-------------------------------------------------------
d <- NA; d; is.na(d)

## ----functionCharacter---------------------------------------------------
b <- "ABCABD"; nchar(b)
substr(b, 1, 3)
b <- tolower(b); b; toupper(b)

## ----operationCharacter--------------------------------------------------
a <- "a"; b <- "abcabd"; paste(a,b,sep="-")
strsplit(b,a)
grep(a, b); gsub(a,"",b)

## ----variableLogical-----------------------------------------------------
d <- is.numeric(b); d; mode(d)
as.numeric(d); as.character(d); as.logical(1)

## ----functionLogical-----------------------------------------------------
e <- !d; e
d|e; e&d

## ----functionLogical2----------------------------------------------------
e
e+e;
as.logical("0")

## ----vectors-------------------------------------------------------------
a.vector <- c(a, b, d, e); a.vector
mode(a.vector); length(a.vector)

## ----vectorOperation-----------------------------------------------------
nchar(a.vector)
a <- c(1:5,NA); b <- seq(1,100,length=5); a; b
a*b # !! this is not a dot product

## ----vectorOperator------------------------------------------------------
a; sum(a); sum(a, na.rm=TRUE)
sum(a > 2, na.rm=TRUE)

## ----vectorOperator2-----------------------------------------------------
a; b <- rep(1:6, each=2); b
unique(b); intersect(a,b); union(a,b)

## ----vectorSubsetting----------------------------------------------------
b <- rep(1:3, 2); b; 
b>2; which(b>2); b[c(3,6)]; b[b>2]

## ----vectorOperation2----------------------------------------------------
b <- rep(1:3, each=2); b; 
which(b>5); length(which(b>5))
b==2; 

## ----factor--------------------------------------------------------------
a.factor <- as.factor(a.vector); a.factor
class(a.factor); levels(a.factor); nlevels(a.factor)

## ----factorOperation-----------------------------------------------------
a.factor[3] <- "2"; a.factor
a.factor[3] <- "a"; a.factor
levels(a.factor) <-5:8; a.factor

## ----factorOperation2----------------------------------------------------
as.character(a.factor)
as.numeric(a.factor)

## ----listingRemoving-----------------------------------------------------
ls()
rm(iris); ls()
rm(list=ls())

## ----ex1-----------------------------------------------------------------
a <- c(1, 5, 3, 4); b <- letters[5:7]
a; b

## ----ex1-answer, echo=FALSE----------------------------------------------
d <- c(a[1:2], b, a[3:4])

## ----ex1-res-------------------------------------------------------------
d

## ----ex2-----------------------------------------------------------------
a <- c(1, 2, NA, 3:7); a; b <- 1:7; all.equal(a,b)

## ----ex2-answer, echo=FALSE----------------------------------------------
a <- a[!is.na(a)]

## ----ex2-res-------------------------------------------------------------
all.equal(a, b)

## ----ex3-----------------------------------------------------------------
set.seed(1119)
as <- sample(1:5, 100, replace=TRUE)
head(as); tail(as)

## ----ex3-res, echo=FALSE-------------------------------------------------
sum(as==5)

