## ----checkWD-------------------------------------------------------------
getwd()

## ----setWD, eval=FALSE---------------------------------------------------
## set.wd("~/Rlesson3") # not run

## ----downloadURL---------------------------------------------------------
fileURL <- "http://www.nathalievilla.org/doc/csv/ex-data-tide.csv"
dir.create("data")
download.file(fileURL, destfile="data/ex-data.csv")
list.files("data")
ls()

## ----readText------------------------------------------------------------
df <- read.table("data/ex-data.csv", sep=";", header=TRUE)
summary(df[,1:3])

## ----importCSV-----------------------------------------------------------
df <- read.csv2("data/ex-data.csv", stringsAsFactor=FALSE)
summary(df[,4:5])

## ----importTextAsIs------------------------------------------------------
cur.conn <- url(fileURL) # open connexion
df2 <- readLines(cur.conn, n=3)
lapply(df2, substr, start=1, stop=15) # first 15 characters
close(cur.conn) # close connexion

## ----textExport----------------------------------------------------------
write.table(df, file="data/export-data.txt")
write.csv2(df, file="data/export-data.csv",
           row.names=FALSE)

## ----rdaExport-----------------------------------------------------------
data(iris); ls()
save(df, iris, file="data/export-ws.rda")

## ----rdaLoading----------------------------------------------------------
rm(list=ls()); ls()
load("data/export-ws.rda"); ls()
load("data/export-ws.rda", verbose=TRUE)

## ----ex1-res, echo=FALSE-------------------------------------------------
df <- read.csv2("co2.csv", dec=",",
                row.names=1)

## ----ex1-res2, echo=FALSE, results='hide'--------------------------------
dim(df)

## ----ex1-res3, echo=FALSE, results='hide'--------------------------------
names(df)
sapply(df, class)

## ----ex3-res4, echo=FALSE, results='hide'--------------------------------
table(df$Type, df$Treatment)

## ----ex3-res5, echo=FALSE, results='hide'--------------------------------
tapply(df$uptake, df$Type, median)

## ----removeDir, echo=FALSE-----------------------------------------------
unlink("data", recursive=TRUE)

