## ----ifEx1---------------------------------------------------------------
x <- sample(1:10, 1); x
if (x > 5) {
  print("I am large!")
}

## ----ifEx2---------------------------------------------------------------
x <- sample(letters[1:5], 1); x
if (x %in% c("a","e")) {
  print("I am a vowel!")
} else {
  print("I am not a vowel. ")
}

## ----switch--------------------------------------------------------------
x <- sample(letters[1:5], 1); x
res <- switch(x,
              "a"="b", "b"="c", "c"="d",
              "d"="e", "e"="f")
res

## ----firstF--------------------------------------------------------------
myFirstFunction <- function(x) {
  res <- x^2+1
  return(res)
}
myFirstFunction; myFirstFunction(1)
sapply(seq(0,1,length=5),
       myFirstFunction)

## ----firstF2-------------------------------------------------------------
myFirstFunction <- function(x) {
  if (!is.numeric(x)) {
    stop("argument 'x' must be numeric")
  }
  res <- x^2+1
  return(res)
}
myFirstFunction(1)
## Not run: calling myFirstFunction("A") returns an error

## ----funcDef-------------------------------------------------------------
myFirstFunction <- function(x=0) {
  res <- x^2+1
  return(res)
}
myFirstFunction(); myFirstFunction(1)

## ----funcDef2------------------------------------------------------------
mySecondFunction <- 
  function(x=c("A","B","C")) {
    x <- match.arg(x) # gestion of error
    res <- paste("this is a", x)
    return(res)
}
mySecondFunction(); mySecondFunction("C")
## Not run: mySecondFunction(1) returns an error

## ----funcMultIO----------------------------------------------------------
myThirdFunction <- function(x, y=2) {
    return(list("val"=x, "power"=x^y))
}
myThirdFunction(2); myThirdFunction(2, 3)

## ----forEx---------------------------------------------------------------
for (ind in 1:10) {
  cat(ind," ")
}

## ----compareLoops--------------------------------------------------------
system.time({for (ind in 1:100000) ind^2})
system.time((1:100000)^2)

## ----compareLoops2-------------------------------------------------------
data(USArrests)
system.time({for (ind in 1:100000) mean(USArrests)})
system.time(apply(USArrests, 2, mean))

## ----repeatLoop----------------------------------------------------------
ind <- 1
repeat {
  ind <- ind+1
  cat(ind, " ")
  
  if (ind > 10) break
}

## ----whileLoop-----------------------------------------------------------
ind <- 1
while (ind < 10) {
  ind <- ind+1
  cat(ind, " ")
}

## ----ex1-res1, echo=FALSE------------------------------------------------
myFavoriteStats <- function(a.vect) {
  res <- c(mean(a.vect, na.rm=TRUE), median(a.vect, na.rm=TRUE), 
           sd(a.vect, na.rm=TRUE), min(a.vect, na.rm=TRUE), 
           max(a.vect, na.rm=TRUE))
  names(res) <- c("mean", "median", "sd", "min", "max")
  return(res)
}

## ----ex1-todo1, echo=FALSE-----------------------------------------------
data(USArrests)
apply(USArrests, 2, myFavoriteStats)

## ----ex2-res1, echo=FALSE------------------------------------------------
sumCalc <- function(number) {
  digit.sum <- 0
  while (number != 0) {
    digit.sum <- number %% 10 + digit.sum
    number <- number %/% 10
  }
  return(digit.sum)
}

## ----ex2-todo1-----------------------------------------------------------
sumCalc(123)

## ----ex2-operators-------------------------------------------------------
123%%10; 123%/%10

## ----ex2-res2, echo=FALSE------------------------------------------------
prodCalc <- function(number) {
  digit.prod <- 1
  while (number != 0) {
    digit.prod <- number %% 10 * digit.prod
    number <- number %/% 10
  }
  return(digit.prod)
}

## ----ex2-todo2-----------------------------------------------------------
prodCalc(123)

## ----ex2-res3, echo=FALSE------------------------------------------------
checkEqual <- function(n) {
  return(sumCalc(n)==prodCalc(n))
}

## ----ex2-todo3-----------------------------------------------------------
checkEqual(123)

## ----ex2-todo4, echo=FALSE-----------------------------------------------
res <- sapply(1:100, checkEqual)
(1:100)[res]

